Graphics3D 800,600,0,2

Global PalR[1024]
Global PalG[1024]
Global PalB[1024]
Global PalZ[1024]
Global PalBrush[1024]
Global PalTo

Global avail$[1024]
Global avto=-1
Global avat=0

quickin=ReadDir("Input/")
Repeat
	in$=NextFile(quickin)
	If Upper$(Right$(in$,4))=".PNG"
		If avto<1023
			avto=avto+1
			avail[avto]=in$
		EndIf
	EndIf
Until in$=""
CloseDir(quickin)
If avto<0 Then End

Global BlockZ[1048576]
Global BlockPalette[1048576]

Global Layer[128]
Global Lay=0


Global wasview=0

Global objW,objH

Global world

Global flatback=1
Global chunkier=0
Global outline=0

Global overscale=0

Global hit2

AntiAlias True

Loadimg(avail[avat])


Global campivot=CreatePivot()
Global cam=CreateCamera(campivot)
MoveEntity cam,0,0,512

AmbientLight 128,128,128

ClsColor 180,180,180

UpdateMesh(0)

Repeat
Cls

If cam<>0
	CameraViewport cam,2,64,640,512
	RenderWorld
EndIf

x=800-128
flatback=Clicky(flatback,x,24,"Flat Back")
overscale=Clicky(overscale,x,48,"Larger Scale")

x=x-128
chunkier=Clicky(chunkier,x,24,"Chunkier")
x=x-128
outline=Clicky(outline,x,24,"Outline")


view=MouseDown(1)
If view<>WasView Then UpdateMesh(view)


Color 0,0,0
If MouseY()<16 And MouseX()<128
	Color 255,255,255
	If (MouseDown(1) Or KeyHit(205)) And hit2=0
		Repeat
			hit2=1
			avat=avat+1
			If avat>avto Then avat=0
			did=LoadImg(avail[avat])
			UpdateMesh(0)
		Until did>-1
	EndIf
	If (MouseDown(2) Or KeyHit(203)) And hit2=0
		Repeat
			hit2=1
			avat=avat-1
			If avat<0 Then avat=avto
			did=LoadImg(avail[avat])
			UpdateMesh(0)
		Until did>-1
	EndIf
EndIf


	If (KeyHit(205)) And hit2=0
		Repeat
			hit2=1
			avat=avat+1
			If avat>avto Then avat=0
			did=LoadImg(avail[avat])
			UpdateMesh(0)
		Until did>-1
	EndIf
	If (KeyHit(203)) And hit2=0
		Repeat
			hit2=1
			avat=avat-1
			If avat<0 Then avat=avto
			did=LoadImg(avail[avat])
			UpdateMesh(0)
		Until did>-1
	EndIf



Text(0,0,avail[avat],0,0)

Color 0,0,0

RotateEntity campivot,Sin(MilliSecs()/6)*8.0,Cos(MilliSecs()/9)*8.0,0

If MouseX()<642 And MouseY()>64 And MouseY()<64+512
	RotateEntity campivot,MouseY(),-MouseX(),0
EndIf


For p=0 To PalTo-1
	Color PalR[p],PalG[p],PalB[p]
	y=(p*16)+64
	Rect(650,y,14,14,1)
	
	If MouseX()>664 And MouseY()>y And MouseY()<y+14 And MouseDown(1); And hit=0
		hit=1
		h=MouseX()-720
		PalZ[p]=h
		wasview=-1
	EndIf
	
	Color(0,0,0)
	Rect(664,y,PalZ[p]+56,14)
Next

Color(0,0,0)
If MouseX()<128 And MouseY()<96 And MouseY()>24
	Color(255,255,255)
	If MouseDown(1) Then ExportToSTL
EndIf
Text(12,32,"Export STL",0,0)

If KeyHit(31) Then ExportToSTL

If MouseDown(1)=0 Then hit=0
If MouseDown(1)=0 And MouseDown(2)=0 Then hit2=0

Flip False
Delay 5
If KeyDown(1) Then fin=1
If KeyDown(62) Then fin=1
Until fin=1

End


Function Clicky(vbl,x,y,desc$)
u$="[x]"
If vbl=0 Then u$="[ ]"
Color (0,0,0)
If Abs((MouseX()-(x+52)))<52 And Abs(MouseY()-y)<9
	Color(255,255,255)
	If MouseDown(1) And hit2=0
		hit2=1
		vbl=1-vbl
	EndIf
EndIf

Text(x,y,u$+desc$,0,1)

Return vbl
End Function

Function LoadImg(filename$)
filename$="Input/"+filename$
img=LoadImage(filename$)
ObjW=ImageWidth(img)
ObjH=ImageHeight(img)
allowed=1



pixelcount=0
LockBuffer(ImageBuffer(img))
For x=0 To w-1
For y=0 To h-1
	i=(y*1024)+x
	BlockZ[i]=1
	argb=ReadPixelFast(x,y,ImageBuffer(img))
	r=(argb And $00FF0000) Shr 16
	g=(argb And $0000FF00) Shr 8
	b=(argb And $000000FF)
	If (r=255 And g=0 And b=255)=0
		pixelcount=pixelcount+1
	EndIf
Next
Next

UnlockBuffer(ImageBuffer(img))

If pixelcount>2700 Then allowed=0

If allowed=0
	FreeImage img
	Return -1
EndIf


For n=0 To 1023
	PalR[n]=0
	PalG[n]=0
	PalB[n]=0
	PalZ[n]=0
	PalBrush[n]=0
Next

w=ObjW
h=ObjH
If w>1024 Then w=1024
If h>1024 Then h=1024
PalTo=0

For n=0 To 1023
	PalZ[n]=0
Next

LockBuffer(ImageBuffer(img))
For x=0 To w-1
For y=0 To h-1
	i=(y*1024)+x
	BlockZ[i]=1
	argb=ReadPixelFast(x,y,ImageBuffer(img))
	r=(argb And $00FF0000) Shr 16
	g=(argb And $0000FF00) Shr 8
	b=(argb And $000000FF)
	f=-1
	For q=0 To PalTo-1
		If PalR[q]=r And PalG[q]=g And PalB[q]=b Then f=q
	Next
	If f=-1 And (r=255 And g=0 And b=255)=0
		PalTo=PalTo+1
		f=PalTo-1
		PalR[f]=r
		PalG[f]=g
		PalB[f]=b
	EndIf

	
	
	If r<>255 Or g<>0 Or b<>255 Then BlockPalette[i]=f
	If r=255 And g=0 And b=255 Then BlockPalette[i]=-1
Next
Next

UnlockBuffer(ImageBuffer(img))

FreeImage img

Return 1
End Function


Function UpdateMesh(AllWhite)

WasView=AllWhite

w=ObjW
h=ObjH

If layer[lay]<>0
	FreeEntity layer[lay]
	layer[lay]=0
EndIf

ClearWorld

cam=0

For n=0 To 1023
	PalBrush[n]=CreateBrush(PalR[n],PalG[n],PalB[n])
Next

campivot=CreatePivot()
cam=CreateCamera(campivot)
CameraClsColor cam,100,0,100


layer[lay]=CreateMesh()

outbrush=CreateBrush(0,0,0)
outbox=CreateCube()
ScaleMesh(Outbox,0.8,0.8,0.2)
PositionMesh outbox,0,0,-0.01
PaintMesh outbox,outbrush

box=CreateCube()
If chunkier=0 Then ScaleMesh box,0.5,0.5,0.5
If chunkier=1 Then ScaleMesh box,0.6,0.6,0.5

zoom=w+2
If h+2>zoom Then zoom=h+2

PositionMesh box,w/2,h/2,0
PositionMesh outbox,w/2,h/2,0

white1=CreateBrush(255,255,255)
white2=CreateBrush(253,253,253)


For x=0 To w-1
For y=0 To h-1
	
	i=(y*1024)+x

	fz#=1.0
	u=BlockPalette[i]
	If u>-1 And u<1024

		fz#=PalZ[u]
		fz=(fz/52.0)		
		fz=fz+1.0
		If overscale=1 And fz>1.0 Then fz=fz*fz*3.0
		fz2#=fz/2.0
		
		If flatback=0
			fz#=PalZ[u]
			fz=(fz/(52.0/2.0))
			fz=fz+1.0
			fz2#=0
		EndIf
	EndIf
	
	PositionMesh box,-x,-y,0
	PositionMesh outbox,-x,-y,0
	ScaleMesh box,1,1,fz
	PositionMesh box,0,0,fz2
	
	
	If u>-1 And u<1024 And AllWhite=0		
		PaintMesh box,PalBrush[u]
		AddMesh box,layer[lay]
;		abox=CopyMesh(box)
	EndIf
	If u>-1 And u<1024 And AllWhite=1
		PaintMesh box,white1
		If (x Mod 4)=0 Then PaintMesh box,white2
		AddMesh box,layer[lay]
;		abox=CopyMesh(box)
	EndIf

	If u>-1 And u<1024 And outline=1
		AddMesh outbox,layer[lay]
	EndIf

	
	PositionMesh box,0,0,-fz2
	ScaleMesh box,1,1,1.0/fz
	PositionMesh outbox,x,y,0
	PositionMesh box,x,y,0
Next
Next

FreeEntity box
FreeEntity outbox

lamp=CreateLight(2,campivot)
MoveEntity lamp,-300,-400,100
PointEntity lamp,campivot
MoveEntity cam,0,0,zoom
RotateEntity cam,0,180,0
;UpdateNormals layer[lay]

Delay 2

End Function


Function ExportToSTL()
UpdateMesh(1)

Cls
Flip
Delay 10

fn$=avail[avat]
fn$=Replace(fn$,".png","")
fn$=Replace(fn$,".PNG","")
fn$=Replace(fn$,".Png","")

quicky=WriteFile("Output/"+fn$+"_"+CurrentDate$()+".stl")
WriteLine(quicky,"solid "+fn$)

count=CountSurfaces(layer[lay])
For n=1 To count
	surf=GetSurface(layer[lay],n)
	countt=CountTriangles(surf)
	countv=CountVertices(surf)
	For m=0 To countt
		can=0
		For p=0 To 2
			point=TriangleVertex(surf,m,p)

			If point<=countv
				can=can+1
	DebugLog surf+":"+countt+":"+countv+":"+m+":"+p+":"+point

				x#=VertexX(surf,point)
				y#=VertexY(surf,point)
				z#=VertexZ(surf,point)
				xn#=VertexNX(surf,point)
				yn#=VertexNY(surf,point)
				zn#=VertexNZ(surf,point)
			EndIf
		Next

If can<3
	DebugLog can
	DebugLog "       "+surf+":"+countt+":"+countv+":"+m+":"+p+":"+point
EndIf

		If can>2
				xn#=-VertexNX(surf,1)
				yn#=VertexNY(surf,1)
				zn#=VertexNZ(surf,1)

				WriteLine(quicky,"  facet normal "+xn+" "+yn+" "+zn)
				WriteLine(quicky,"     outer loop")
				For p=0 To 2
					point=TriangleVertex(surf,m,p)
					If point<=countv
						x#=-VertexX(surf,point)
						y#=VertexY(surf,point)
						z#=VertexZ(surf,point)
						WriteLine(quicky,"        vertex "+x+" "+y+" "+z)
					EndIf
				Next
				WriteLine(quicky,"     endloop")
				WriteLine(quicky,"  endfacet")
		EndIf

	Next
Next

WriteLine(quicky,"endsolid "+fn$)

CloseFile quicky
UpdateMesh(0)
End Function